%Function M-file: vafdtd_auralization.m
%
%Usage		: vafdtd_auralization(fs, nbit, str1, istr1, ...)
%Version	: 1.1.03 (2024.1.27)
%
%fs			: Output Sampling Frequency
%nbit		: Output Bits per Sample
%str		: Sequence File Name
%istr		: Position Name

function vafdtd_auralization(varargin);

col = [	122/255  16/255 228/255;
		 20/255  43/255 140/255;
		216/255  41/255   0/255;
		  0/255 127/255   0/255;
		222/255 125/255   0/255;
		 11/255 132/255 199/255;
		174/255 119/255   0/255 ];

fs		= varargin{1};
nbit	= varargin{2};
ima		= (nargin - 2) / 2;

for i = 1 : ima;
	st1{i}	= varargin{2 * i + 1};
	st2{i}	= varargin{2 * i + 2};
	st{i}	= [st1{i} '_' st2{i}];
end;

for i = 1 : ima;

	fid1	= fopen([st1{i} '.ini'], 'r');
	fid2	= fopen([st{i}], 'r');

	param	= fread(fid1, [inf], 'float64');
	fclose(fid1);

	dt		= param(1);
	if(isempty(strfind(st2{i}, 'rpt')));
		timeskip	= 1;
	else
		timeskip	= param(19+param(19)+str2num(strrep(st2{i}, 'rpt', ''))+1);
	end;

	p	= fread(fid2, [inf], 'float64');

	fclose(fid2);

	fs	= round(fs);
	fsx	= round(1 / (dt * timeskip));

	while fs * fsx >= 2^31;
		p	= decimate(p, 10);
		fsx	= round(fsx / 10);
	end;

	p	= resample(p, fs, fsx);
	p	= p / max(abs(p)) / 1.01;

	audiowrite([st1{i} '_' st2{i} '.wav'], p, fs, 'BitsPerSample', nbit);

end;

end